function [B, Bbar] = strainDecomposition(xia)
%% STRAINDECOMPOSITION
%
% [B, BBAR] = STRAINDECOMPOSITION(XIA) turns allowed strains XIA into the
% allowed strain matrix B and the constrained strain matrix BBAR.
%
% Inputs:
%  
%   XIA                     6x1 vector of allowed strains with XIA = [ KA , GA ]
%                           where KA = 3x1 are allowed angular strains and
%                           GA = 3x1 are allowed linear strains.
%
% Outputs:
%
%   B                       6xA allowed strain mapping matrix where A is the
%                           number of allowed strains.
% 
%   BBAR                    6x(6-A) constrained strain mapping matrix.
%
% Authors:
%   Philipp Tempel <philipp.tempel@ls2n.fr>



%% Parse arguments

% STRAINDECOMPOSITION(XIA)
narginchk(1, 1);

% STRAINDECOMPOSITION(___)
% B = STRAINDECOMPOSITION(___)
% [B, BBAR] = STRAINDECOMPOSITION(___)
nargoutchk(0, 2);



%% Algorithm

% Find allowed strain measures
idx = xia(:) >= 0.5;
n_a = sum(idx);
n_c = 6 - n_a;

% Full selection matrix
E = eye(6, 6);

% Build selection matrix of allowed strains
B = E(:,idx);
% Build selection matrix of constrained strains
Bbar = E(:,~idx);



%% Validate Matrices

validateattributes( ...
  B ...
  , { 'numeric' , 'logical' } ...
  , { ...
      '2d' ...
    , 'nrows', 6 ...
    , 'ncols', n_a ...
    , 'binary' ...
  } ...
);
validateattributes( ...
  Bbar ...
  , { 'numeric' , 'logical' } ...
  , { ...
      '2d' ...
    , 'nrows', 6 ...
    , 'ncols', n_c ...
    , 'binary' ...
  } ...
);
% B^T * B must be eye matrix
validateattributes( ...
  transpose(B) * B ...
  , { 'numeric' , 'logical' } ...
  , { ...
      '2d' ...
    , 'square' ...
    , 'nrows', n_a ...
    , 'ncols', n_a ...
    , 'binary' ...
    , 'diag' ...
  } ...
);
% B^T * \bar{B} must be zeros
validateattributes( ...
  transpose(B) * Bbar ...
  , { 'numeric' , 'logical' } ...
  , { ...
      '2d' ...
    , 'nrows', n_a ...
    , 'ncols', n_c ...
    , 'binary' ...
    , '<', 1 ...
    , '>=', 0 ...
  } ...
);
% \bar{B}^T * \bar{B} must be eye matrix (or empty, if n_c == 0)
if n_c > 0
  validateattributes( ...
    transpose(Bbar) * Bbar ...
    , { 'numeric' , 'logical' } ...
    , { ...
        '2d' ...
      , 'square' ...
      , 'nrows', n_c ...
      , 'ncols', n_c ...
      , 'binary' ...
      , 'diag' ...
    } ...
  );
end


end

%------------- END OF CODE --------------
% Please send suggestions for improvement of this file to the original author as
% can be found in the header. Your contribution towards improving this function
% will be acknowledged in the "Changelog" section of the header.
